summaryrefslogtreecommitdiff
path: root/tests/test-admin-upgrade-not-backwards.sh
diff options
context:
space:
mode:
authorColin Walters <walters@verbum.org>2014-02-20 18:25:56 -0500
committerColin Walters <walters@verbum.org>2014-02-20 18:25:56 -0500
commitf2e0162846cbb84abf6fd9a38fabdfd588f4eb2f (patch)
tree8d9ca05c4cc01f535e8441fc48c452bc6045a602 /tests/test-admin-upgrade-not-backwards.sh
parent9fc9008af8374e7c983a26c18f200e6c7bbf8cbb (diff)
downloadostree-f2e0162846cbb84abf6fd9a38fabdfd588f4eb2f.tar.gz
upgrade: Refuse chronologically older commits unless --allow-downgrade
We don't want to allow MITM attackers to intercept upgrade requests and provide clients with older OS versions vulnerable to security flaws. Only "ostree admin upgrade" gets this behavior for now - whether we want to do it for "ostree admin switch" is another question.
Diffstat (limited to 'tests/test-admin-upgrade-not-backwards.sh')
-rw-r--r--tests/test-admin-upgrade-not-backwards.sh57
1 files changed, 57 insertions, 0 deletions
diff --git a/tests/test-admin-upgrade-not-backwards.sh b/tests/test-admin-upgrade-not-backwards.sh
new file mode 100644
index 00000000..6ea988b8
--- /dev/null
+++ b/tests/test-admin-upgrade-not-backwards.sh
@@ -0,0 +1,57 @@
+#!/bin/bash
+#
+# Copyright (C) 2014 Colin Walters <walters@verbum.org>
+#
+# This library is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Lesser General Public
+# License as published by the Free Software Foundation; either
+# version 2 of the License, or (at your option) any later version.
+#
+# This library is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# Lesser General Public License for more details.
+#
+# You should have received a copy of the GNU Lesser General Public
+# License along with this library; if not, write to the
+# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
+
+set -e
+
+. $(dirname $0)/libtest.sh
+
+echo "1..1"
+
+setup_os_repository "archive-z2" "syslinux"
+
+echo "ok setup"
+
+echo "1..2"
+
+cd ${test_tmpdir}
+ostree --repo=sysroot/ostree/repo remote add --set=gpg-verify=false testos $(cat httpd-address)/ostree/testos-repo
+ostree --repo=sysroot/ostree/repo pull testos testos/buildmaster/x86_64-runtime
+rev=$(ostree --repo=sysroot/ostree/repo rev-parse testos/buildmaster/x86_64-runtime)
+export rev
+echo "rev=${rev}"
+# This initial deployment gets kicked off with some kernel arguments
+ostree admin --sysroot=sysroot deploy --karg=root=LABEL=MOO --karg=quiet --os=testos testos:testos/buildmaster/x86_64-runtime
+assert_has_dir sysroot/boot/ostree/testos-${bootcsum}
+
+# This should be a no-op
+ostree admin --sysroot=sysroot upgrade --os=testos
+
+# Now reset to an older revision
+ostree --repo=${test_tmpdir}/testos-repo reset testos/buildmaster/x86_64-runtime{,^}
+
+if ostree admin --sysroot=sysroot upgrade --os=testos 2>upgrade-err.txt; then
+ assert_not_reached 'upgrade unexpectedly succeeded'
+fi
+assert_file_has_content upgrade-err.txt 'chronologically older'
+
+echo 'ok upgrade will not go backwards'
+
+ostree admin --sysroot=sysroot upgrade --os=testos --allow-downgrade
+
+echo 'ok upgrade backwards'